'use strict';

var tslib = require('tslib');
var path = require('path');
var fs = require('fs');
var nodeUtils = require('@component-controls/core/node-utils');
var webpackBuild = require('@component-controls/base-integration/webpack-build');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var path__default = /*#__PURE__*/_interopDefaultLegacy(path);
var fs__default = /*#__PURE__*/_interopDefaultLegacy(fs);

// const SegfaultHandler = require('segfault-handler');
// SegfaultHandler.registerHandler('crash.log');
module.exports =
    (_a) => {
        var { bundleName, configPath, presets, staticFolder, distFolder: userDistFolder, webpack, loaders } = _a, rest = tslib.__rest(_a, ["bundleName", "configPath", "presets", "staticFolder", "distFolder", "webpack", "loaders"]);
        return () => {
            const distFolder = nodeUtils.getDistFolder({ distFolder: userDistFolder });
            const buildOptions = {
                bundleName,
                configPath,
                presets,
                distFolder: path__default["default"].resolve(__dirname),
                staticFolder: staticFolder || path__default["default"].join(distFolder, 'static'),
                loaders: Object.assign(Object.assign({}, loaders), { 'mini-css-extract-plugin': {
                        module: require.resolve('next/dist/compiled/mini-css-extract-plugin'),
                    } }),
                webpack,
            };
            return Object.assign({ 
                /**
                 * we need some async function, to make sure the compilation process is completed
                 * headers is the first called from async redirects() amd async rewrites()
                 */
                async headers() {
                    await webpackBuild.buildBundle({
                        options: buildOptions,
                        onEndBuild: ({ store }) => {
                            const cssBundle = nodeUtils.getCSSFilePath(store.config);
                            if (fs__default["default"].existsSync(cssBundle)) {
                                const styles = fs__default["default"].readFileSync(cssBundle, 'utf8');
                                process.env.NEXT_PUBLIC_CC_CSS = JSON.stringify(styles);
                            }
                        },
                    });
                    return [];
                } }, rest);
        };
    };
